
%bcond_with system_lua

%global pkg_name hslua
%global pkgver %{pkg_name}-%{version}

%global hsluacore hslua-core-2.3.1
%global hsluamarshalling hslua-marshalling-2.3.0
%global hsluaobjectorientation hslua-objectorientation-2.3.0
%global hsluapackaging hslua-packaging-2.3.0
%global lua_hs lua-2.3.1
%global hsluaaeson hslua-aeson-2.3.0.1
%global hsluaclasses hslua-classes-2.3.0
%global hsluatyping hslua-typing-0.1.0
%global subpkgs %{lua_hs} %{hsluacore} %{hsluamarshalling} %{hsluatyping} %{hsluaobjectorientation} %{hsluapackaging} %{hsluaaeson} %{hsluaclasses}


Name:           ghc-%{pkg_name}
Version:        2.3.0
Release:    1%{?dist}
Summary:        Bindings to Lua, an embeddable scripting language

License:        MIT
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source1:        https://hackage.haskell.org/package/%{hsluacore}/%{hsluacore}.tar.gz
Source2:        https://hackage.haskell.org/package/%{hsluamarshalling}/%{hsluamarshalling}.tar.gz
Source3:        https://hackage.haskell.org/package/%{hsluaobjectorientation}/%{hsluaobjectorientation}.tar.gz
Source4:        https://hackage.haskell.org/package/%{hsluapackaging}/%{hsluapackaging}.tar.gz
Source5:        https://hackage.haskell.org/package/%{lua_hs}/%{lua_hs}.tar.gz
Source6:        https://hackage.haskell.org/package/%{hsluaaeson}/%{hsluaaeson}.tar.gz
Source7:        https://hackage.haskell.org/package/%{hsluaclasses}/%{hsluaclasses}.tar.gz
Source8:        https://hackage.haskell.org/package/%{hsluatyping}/%{hsluatyping}.tar.gz

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros-extra
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-text-devel
%if %{with ghc_prof}
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-exceptions-prof
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-text-prof
%endif
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-scientific-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-vector-devel
%if %{with ghc_prof}
BuildRequires:  ghc-aeson-prof
BuildRequires:  ghc-hashable-prof
BuildRequires:  ghc-scientific-prof
BuildRequires:  ghc-unordered-containers-prof
BuildRequires:  ghc-vector-prof
%endif
%if %{with system_lua}
BuildRequires:  lua-devel
%else
Provides:       bundled(lua) = 5.4.4
%endif

%description
HsLua provides bindings, wrappers, types, and helper functions to bridge
Haskell and Lua.

It builds upon the lua package, which allows to bundle a Lua interpreter
with a Haskell program.

Example programs are available in <https://github.com/hslua/hslua-examples>.

%package devel
Summary:        Haskell %{pkg_name} library development files
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       %{name} = %{version}-%{release}
%if %{with system_lua}
Requires:       lua-devel
%endif

%description devel
This package provides the Haskell %{pkg_name} library development files.


%if %{with haddock}
%package doc
Summary:        Haskell %{pkg_name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description doc
This package provides the Haskell %{pkg_name} library documentation.
%endif


%if %{with ghc_prof}
%package prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       %{name}-devel = %{version}-%{release}
Supplements:    (%{name}-devel and ghc-prof)

%description prof
This package provides the Haskell %{pkg_name} profiling library.
%endif


%global main_version %{version}

%if %{defined ghclibdir}
%ghc_lib_subpackage -l MIT %{hsluacore}
%ghc_lib_subpackage -l MIT %{hsluamarshalling}
%ghc_lib_subpackage -l MIT %{hsluaobjectorientation}
%ghc_lib_subpackage -l MIT %{hsluapackaging}
%ghc_lib_subpackage -l MIT %{lua_hs}
%ghc_lib_subpackage -l MIT %{hsluaaeson}
%ghc_lib_subpackage -l MIT %{hsluaclasses}
%ghc_lib_subpackage -l MIT %{hsluatyping}
%endif

%global version %{main_version}


%prep
%setup -q -n %{pkgver} -a1 -a2 -a3 -a4 -a5 -a6 -a7 -a8
%if %{with system_lua}
cabal-tweak-flag system-lua True
rm -r cbits/lua-5.*
%endif


%build
%ghc_libs_build %{subpkgs}
%ghc_lib_build


%install
%ghc_libs_install %{subpkgs}
%ghc_lib_install


%files -f %{name}.files
%license LICENSE


%files devel -f %{name}-devel.files
%doc CHANGELOG.md README.md


%if %{with haddock}
%files doc -f %{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files prof -f %{name}-prof.files
%endif


%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.3.0-1
- initial build
